#ifndef _KBEXP_H_
#define _KBEXP_H_

#include "kbNoteExt.h"
class KbNote;

/**
 * Objects of this class are exps. They do not need a (graphical) presentation of their own. They can be displayed
 * graphically within the presentation of the parts, they belong to. This is done in editors.
 * @short Exp Class
 * @author Jan Wuerthner
 * @version 0.97
 */
class KbExp : public KbNoteExt
{
 private:
  int exp;
  int yoff;

 public:
  KbExp(KbNote*,int);
  KbExp(KbNote*,int,int);
  int gExpression();
  int gOffset();
  void sExpression(int);
  void sOffset(int);
  // virtual KbNoteExt * gNext();
  virtual bool isLyrics();
  virtual bool isStem();
  virtual bool isExp();
  virtual bool isBow();
  virtual ostream & print(ostream&);
  virtual KbNoteExt * copy();
};


#endif
